import {openSelect} from "./_selector-functions";
import {view_initializeMasonry} from "./_view-functions";
import {opener_close, opener_selectOption} from "./_opener-functions";


/**
 *
 * @param {DzsSelector} selfInstance
 */
export function setup_listeners(selfInstance) {
  var $ = jQuery;
  var o = selfInstance.initOptions;

  if (selfInstance.$selectInputForm) {

    selfInstance.$selectInputForm.on('change.dzssel', handle_changeSelectInputForm(selfInstance));
    selfInstance.$selectInputForm.on('focus', handle_focusSelectInputForm);
    selfInstance.$selectInputForm.on('focusout', handle_focusSelectInputForm);


    selfInstance.$selectInputForm.get(0).selector_wrap = selfInstance.$wrapperMain;
    if (selfInstance.$selectInputForm.hasClass('do-not-trigger-change-on-init')) {
      selfInstance.$selectInputForm.trigger('change');
    }

  }


  if (String(selfInstance.feedElementClass).indexOf('opener-') > -1) {


    var $wrapperHead = selfInstance.$dzsSelectorMain.parent().find('.dzs-select-wrapper-head');


    $wrapperHead.data('selector_wrap', selfInstance.$wrapperMain)


    $wrapperHead.on('click', handle_clickWrapperHead)
  } else {


    if (selfInstance.$wrapperMain) {
      selfInstance.$wrapperMain.find('.dzs-select-wrapper-head').on('click', function () {
        openSelect(selfInstance.$selectInputForm);
      })
    }
  }


  if (o.opener === ('opener-listbuttons') || o.opener === ('opener-bigoptions') || o.opener === ('opener-radio') || o.opener === ('opener-list')) {


    selfInstance.$openerMain.find('.bigoption').unbind('click');
    selfInstance.$openerMain.find('.bigoption').bind('click', handle_mouse);
  }


  selfInstance.$wrapperMain.on('keyup.dzssel', '.search-field', handle_changeSearchField);

  // -------- functions
  // -------- below


  function handle_mouse(e) {
    var _t = $(this);

    if (e.type === 'click') {
      if (_t.hasClass('select-option')) {

        if (!window.dzssel_click_triggered) {
          var _t2 = $(this);


          // -- active


          // -- if it is select, remove other selected


          var currentIndexSelected = _t2.parent().children('.select-option').index(_t2);


          window.dzssel_click_triggered = true;

          setTimeout(function () {
            window.dzssel_click_triggered = false;
          }, 50);


          if (selfInstance.$selectInputForm) {
            selfInstance.$selectInputForm.children().eq(currentIndexSelected).prop('selected', true);
            selfInstance.$selectInputForm.trigger('change');
          } else {

            opener_selectOption(selfInstance, currentIndexSelected, undefined);
          }

          var str_curr_selected = selfInstance.constructSelectedOptionsString();

          selfInstance.setLabel(str_curr_selected);
          if (selfInstance.selectorOptions.type === 'select') {
            opener_close(selfInstance)();
          }

        }


      }
    }
  }


  /**
   *
   * @param {KeyboardEvent} e
   */
  function handle_changeSearchField(e) {
    var _t = $(this);

    if (e.type === 'keyup') {
      if (_t.hasClass('search-field')) {


        const searchedValue = _t.val();

        if (searchedValue) {

        }
        selfInstance.$openerMain.children().each(function () {
          var $option = $(this);
          if (String($option.text()).toLowerCase().indexOf(String(searchedValue).toLowerCase()) > -1) {
            $option.show();
          } else {
            $option.hide();
          }

          if (searchedValue === '') {
            $option.show();
          }
        })
      }
    }
  }


  function handle_clickWrapperHead(e) {
    var _t2 = $(this).data('selector_wrap');


    if ($(e.target).hasClass('search-field')) {


    } else {


      if (_t2.hasClass('active-animation')) {

        if (selfInstance.selectorOptions.nativeInputType !== 'checkbox') {

        }
        selfInstance.close_opener({
          'call_from': 'opener click'
        });

      } else {
        selfInstance.open_opener();
      }

    }


    setTimeout(function () {

      view_initializeMasonry(selfInstance);
    }, 500)

  }


  function handle_focusSelectInputForm(e) {

    if (e.type === 'focusout') {
      selfInstance.$wrapperMain.removeClass('select-focused');
    }
    if (e.type === 'focus') {

      if (selfInstance.$wrapperMain.hasClass('skin-beige')) {
        selfInstance.$wrapperMain.addClass('select-focused');
      }
    }
  }


  /**
   *
   * @param {DzsSelector} selfInstance
   */
  function handle_changeSelectInputForm(selfInstance) {
    return function () {


      var val = '';
      let currentIndexSelected = 0;


      if (selfInstance.$selectInputForm.length) {

        const $selectedHtml = selfInstance.$selectInputForm.find(':selected');
        val = $selectedHtml.html();
        currentIndexSelected = selfInstance.$selectInputForm.children().index($selectedHtml);

        if (selfInstance.selectorOptions.opener.indexOf('opener-') > -1) {
          opener_selectOption(selfInstance, currentIndexSelected, undefined);
        } else {
          selfInstance.setLabel(val);
        }
      }


    }
  }
}